/*
  RCTractor.h - Library for controlling RC Tractors.
  Created by Oisin O'Conchubhair, September 20, 2015.
  Released into the public domain.
*/
#ifndef RCTractorControllerV2_h
#define RCTractorControllerV2_h

#include "Arduino.h"
#include <RCTractorControllerAdafruit_GFX.h>    // Core graphics library
#include <RCTractorControllerAdafruit_TFTLCD.h> // Hardware-specific library
//#include <Adafruit_GFX.h> // Hardware-specific library
//#include <MCUFRIEND_kbv.h>
#include <SD.h>

class RCTractorControllerV2
{
  public:
    RCTractorControllerV2(int Controller_Ver);
    void Update();
    void Check_Light_Buttons();
    void Check_Func_Buttons();
    void Check_Fast_Select();
    void Check_Joys();
    void Check_Encoders();
    void Menu_Update();
    void Setup(int Controller_Num);
	long readVcc();
	void Controller_Voltage();
	void Vehicle_Voltage(long _Vehcile_V);
	    void MenuPosition(int Position);
	    void MenuBackground1();
	    void MenuBackground2();
	    void MenuBackground3();
	    void MenuBackground4();
	    void MenuBackground5();
	    void MenuBackground6();
	    void MenuBackground7();
	    void MenuBackground8();
	    void MenuBackground9();
	    void MenuBackground10();
	    void MenuBackground11();
	    void Start_Vehicle();
	    	    void Start_Hitachi();
void Start_Humanoid();
	    void Start_Control32();
	    void Control32_Pulse(int Num_Pulse);
	    void Start_IR_Heli();
	      	void Start_Game();
	      	void Select_Tool();
	      	void Start_TV();
	      	void Draw_Dash();
	      	void Update_Dash(int clear);
	      	void Update_Controller_Details();
	      	void Draw_Controller_Details();


  private:
  	void Send_NRF();
  	void Send_IR32();
  	void Send_XBee();
  	void Indicator_Symbol();
  	void Light_Symbol();
  	unsigned long BackgroundText();
  	void bmpDraw(char *filename, int x, int y);
  	uint16_t read16(File f);
  	uint32_t read32(File f);
	void placeBeacon();
	void drawSnakeHead();
	void updatePositions();
	boolean beaconIsEaten();
	void moveTheSnake();
  	void moveBall();
  	boolean inPaddle(int x, int y, int rectX, int rectY, int rectWidth, int rectHeight);

unsigned char bitswap (unsigned char x);

void intro();
void Brickmenu();
void settings();
void initGame();
void characterInfo();
void BrickmoveBall();
void brickLogic();
boolean ballInPaddle(int x, int y, int rectX, int rectY, int rectWidth, int rectHeight);
void bricks();
boolean ballInBrick(int x, int y, int rectX, int rectY, int rectWidth, int rectHeight);
boolean cursorInText(int x, int y, int rectX, int rectY, int rectWidth, int rectHeight);
void triangle(int x, int y);
void triangleRed(int x, int y);
void triangleErase(int x, int y);
void destroyBrick(int x, int y);
void loseScreen();
void winScreen();


    int _Motor_PWM;
    int _Motor_con1;
    int _Motor_con2;
    int _Motor_Move;
    int _Left_Ind;
    int _Right_Ind;
    int _Left_Ind_On;
    int _Right_Ind_On;
    int _Timer1_Counter;
    int _Light_Val;
    int _Head_Lights;
    int _Brake_Lights;
    int _Spot_Lights;
    int _Vehicle_No;
    int _V_ID;

  int _JX_L;
  int _JY_L;
  int _JX_R;
  int _JY_R;
  int _S_Left_Joy;
  int _S_Right_Joy;
  int _VQS_V1;
  int _VQS_V2;
  int _VQS_V3;
  int _VQS_V4;
  int _VQS_V5;
  int _VQS_V6;
  int _VQS_V7;
  int _VQS_V8;
  int _VQS_V9;
  int _VQS_V10;
  int _S_DB;
  int _S_FB;
  int _S_WL;
  int _S_F1;
  int _S_F2;
  int _S_F3;
  int _S_Up;
  int _S_EN1;
  int _S_EN2;
  int _S_Down;
  int _S_Select;
  int _S_Back;
  int _DIP1;
  int _DIP2;
  int _DIP3;
  int _DIP4;
  int _DIP5;
  int _Left_Joy_X;
  int _Left_Joy_Y;
  int _Right_Joy_X;
  int _Right_Joy_Y;
  int _P1;
  int _P2;
  int _P3;
  int _P4;
  int _Left_Joy_X_Old;
  int _Left_Joy_Y_Old;
  int _Right_Joy_X_Old;
  int _Right_Joy_Y_Old;
  int _P1_Old;
  int _P2_Old;
  int _P3_Old;
  int _P4_Old;
  int _Left_Joy_Button;
  int _Right_Joy_Button;
  int _LED_Data;
  int _FUNC_Data;
  int _IR_LED;



};


#endif